#property copyright "Copyright  2007, CCI-Trailer EA develop by ejoi"
#property link      "www.forex-tsd.com"

#define MAGICEA  20075117

string MagicName = "CCI-Trailer";
extern string MMSettings = "[Set Money Management Settings Below]";
extern bool MM = true; //Money management setting. If set to False it will use static Lots
extern double Lots           = 0.1; //Minimum Lots
extern double MaxLots        = 100; //Maximum Lots
extern double  Risk = 10; //Percent of available margin to risk.
extern int     PairsTraded=0; //If set to 0 then standard MM.  If set to the number of Pairs traded then the risk is divided amongst the number of pairs.

extern string TradeSettings = "[Set Trade Settings below]";
extern int TakeProfit   = 100;
extern int StopLoss     = 500;
extern int TrailingStop = 15;
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICEA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+  
double LotSize(){
   double lotMM;
   if(PairsTraded==0){
      lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
   } else {
      lotMM = MathCeil(AccountFreeMargin() * Risk / 10000 /PairsTraded) / 10 ;
   }
   if (MM==true){
   if (lotMM < 0.1) lotMM = Lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if (lotMM > 100) lotMM = MaxLots;
   }
   else lotMM = Lots;
   return (lotMM);
} 
 
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double CCI5,CCI15,CCI30,CCIH1,CCIH4;
   int    send;

//----MultitimeFrame CCI setting

   
   CCI5  = iCCI(NULL,PERIOD_M5,50,PRICE_CLOSE,0);
   CCI15 = iCCI(NULL,PERIOD_M15,50,PRICE_CLOSE,0);
   CCI30 = iCCI(NULL,PERIOD_M30,50,PRICE_CLOSE,0);
   CCIH1 = iCCI(NULL,PERIOD_H1,50,PRICE_CLOSE,0);


//----
 


//---- sell conditions
   if ((CCIH1<0)&&(CCI30<0)&&(CCI15<0)&&(CCI5<0))//op sell
     {
      send=OrderSend(Symbol(),OP_SELL,LotSize(),Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,MagicName+"-Sell",MAGICEA,0,Red);      
      return;
     }
     
//---- buy conditions
   if ((CCIH1>0)&&(CCI30>0)&&(CCI15>0)&&(CCI5>0))//op buy
     {
      send=OrderSend(Symbol(),OP_BUY,LotSize(),Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,MagicName+"-Buy",MAGICEA,0,Blue);      
      return;
     }
   }
    
//----

//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {   
//----
  
   
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICEA || OrderSymbol()!=Symbol()) continue;
      
      //---- check order type 
      if (OrderSymbol()==Symbol() && OrderType()==OP_BUY && Bid-TrailingStop*Point > OrderStopLoss()){
         
            if (Bid > OrderOpenPrice()+TrailingStop*Point) {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,0,0,White);
            }
         } else {
            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-1*Point,0,0,White);
         }               
      if (OrderSymbol()==Symbol() && OrderType()==OP_SELL && Ask-TrailingStop*Point < OrderStopLoss()){   
         
            if (Ask < OrderOpenPrice()-TrailingStop*Point) {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,0,0,White);
            }
         } else {
            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+1*Point,0,0,White);
         }         
      }   
     
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
   
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
   
//----
  }
//+------------------------------------------------------------------+

